KCModuleLoader Class Reference
KControl module classes

`#include <kcmoduleloader.h>`

## Public Types

enum | ErrorReporting { None = 0, Inline = 1, Dialog = 2, Both = 3 }

## Static Public Member Functions

static KCModule * | loadModule (const KCModuleInfo &module, bool withFallback=true, QWidget *parent=0, const char *name=0, const QStringList &args=QStringList()) KDE_DEPRECATED
static KCModule * | loadModule (const QString &module, QWidget *parent=0, const char *name=0, const QStringList &args=QStringList()) KDE_DEPRECATED
static KCModule * | loadModule (const KCModuleInfo &module, ErrorReporting report, bool withFallback=true, QWidget *parent=0, const char *name=0, const QStringList &args=QStringList())
static KCModule * | loadModule (const QString &module, ErrorReporting report, QWidget *parent=0, const char *name=0, const QStringList &args=QStringList())
static void | unloadModule (const KCModuleInfo &mod)
static void | showLastLoaderError (QWidget *parent) KDE_DEPRECATED
static bool | testModule (const QString &module)
static bool | testModule (const KCModuleInfo &module)
static KCModule * | reportError (ErrorReporting report, const QString &text, QString details, QWidget *parent)

## Detailed Description

Loads a KControl Module.

KCModuleLoader tries in several ways to locate and load a KCModule. If loading fails a zero pointer is returned.
It is very unlikely KCModuleLoader is what you want and KCModuleProxy suits your needs.

Author
  Matthias Hoelzer-Kluepfel mhk@k.nosp@m.de.o.nosp@m.rg
  Frans Englich frans.nosp@m..eng.nosp@m.lich@.nosp@m.teli.nosp@m.a.com

Since
  3.2

Definition at line 45 of file kcmoduleloader.h.

## Member Enumeration Documentation

enum KCModuleLoader::ErrorReporting

Determines the way errors are reported.

Enumerator
None | no error reporting is done
Inline | the error report is shown instead of the KCModule that should have * been loaded
Dialog | shows a dialog with the error report
Both | does both Inline and Dialog

Definition at line 84 of file kcmoduleloader.h.

## Member Function Documentation

KCModule * KCModuleLoader::loadModule | ( | const KCModuleInfo & | module,
|  | bool | withFallback = `true`,
|  | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | const QStringList & | args = `QStringList()`
| ) |  |

static

Loads a KCModule.

If loading fails a zero pointer is returned.

Parameters

  module | what module to load
  withFallback | if true and loading failed a separate window with the module may appear and a zero pointer is a returned
  parent | The parent widget
  name | The widget's name
  args | A list of arguments for the module to load

Returns
  a pointer to the loaded KCModule

Deprecated:
  use the function which explicitly states the error reporting method

Definition at line 116 of file kcmoduleloader.cpp.

KCModule * KCModuleLoader::loadModule | ( | const QString & | module,
|  | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | const QStringList & | args = `QStringList()`
| ) |  |

static

Loads a KCModule.

If loading fails a zero pointer is returned.

Parameters

  module | what module to load with the module may appear and a zero pointer is a returned
  parent | The parent widget
  name | The widget's name
  args | A list of arguments for the module to load

Deprecated:
  use the function which explicitly states the error reporting method

Definition at line 178 of file kcmoduleloader.cpp.

KCModule * KCModuleLoader::loadModule | ( | const KCModuleInfo & | module,
|  | ErrorReporting | report,
|  | bool | withFallback = `true`,
|  | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | const QStringList & | args = `QStringList()`
| ) |  |

static

Loads a KCModule.

If loading fails a zero pointer is returned.

Parameters

  module | what module to load
  report | see ErrorReporting
  withFallback | if true and loading failed a separate window with the module may appear and a zero pointer is a returned
  parent | The parent widget
  name | The widget's name
  args | A list of arguments for the module to load

Returns
  a pointer to the loaded KCModule

Since
  3.4

Definition at line 121 of file kcmoduleloader.cpp.

KCModule * KCModuleLoader::loadModule | ( | const QString & | module,
|  | ErrorReporting | report,
|  | QWidget * | parent = `0`,
|  | const char * | name = `0`,
|  | const QStringList & | args = `QStringList()`
| ) |  |

static

Loads a KCModule.

If loading fails a zero pointer is returned.

Parameters

  module | what module to load
  report | see ErrorReporting with the module may appear and a zero pointer is a returned
  parent | The parent widget
  name | The widget's name
  args | A list of arguments for the module to load

Returns
  a pointer to the loaded KCModule

Since
  3.4

Definition at line 184 of file kcmoduleloader.cpp.

KCModule * KCModuleLoader::reportError | ( | ErrorReporting | report,
|  | const QString & | text,
|  | QString | details,
|  | QWidget * | parent
| ) |  |

static

Returns a KCModule containing the messages `report` and `text`.

Parameters

  report | the type of error reporting, see ErrorReporting
  text | the main message
  details | any additional details
  parent | The parent widget

Since
  3.4

Definition at line 270 of file kcmoduleloader.cpp.

void KCModuleLoader::showLastLoaderError | ( | QWidget * | parent | ) |

static

Display a message box explaining an error occured and possible reasons to why.

Deprecated:
  Use a constructor with ErrorReporting set to Dialog to show a message box like this function did.

Definition at line 203 of file kcmoduleloader.cpp.

bool KCModuleLoader::testModule | ( | const QString & | module | ) |

static

Checks whether an KCModule should be shown by running its test function.

If it is unsure whether a module should be shown, it should be made available, leaving the decision to the user. If false is returned, the module should not be loaded in any interface.

A module declares it needs to be tested by having "X-KDE-Test-Module=true" in its desktop file. When that line exists, the following code must be available in the module's library:

extern "C"
{
bool test_moduleName()
{
// Code testing for hardware/software presence.
return true; // and the modue will be loaded.
}
}

where moduleName is the library name for the module.

Parameters

  module | the module to check

Returns
  true if the module should be loaded

Since
  3.4

Definition at line 216 of file kcmoduleloader.cpp.

bool KCModuleLoader::testModule | ( | const KCModuleInfo & | module | ) |

static

Convenience function, essentially the same as above.

Parameters

  module | the module to check

Returns
  true if the module should be loaded

Since
  3.4

If something fails we return true - we can't risk functionality becoming unavailable because of a buggy test. Furthermore, the error needs to show so it is discovered. KCModuleProxy will detect the error and load a corresponding KCMError.

Definition at line 221 of file kcmoduleloader.cpp.

void KCModuleLoader::unloadModule | ( | const KCModuleInfo & | mod | ) |

static

Unloads the module's library.

Parameters

  mod | What module to unload for

Definition at line 190 of file kcmoduleloader.cpp.

The documentation for this class was generated from the following files:

- kcmoduleloader.h
- kcmoduleloader.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys